Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security
Class Signature

    java.lang.Object
      |
      +--java.security.SignatureSpi
            |
            +--java.security.Signature

public abstract class Signature
extends SignatureSpi

This Signature class is used to provide applications the functionality of a digital signature algorithm. Digital signatures are used for authentication and integrity assurance of digital data.

The signature algorithm can be, among others, the NIST standard DSA, using DSA and SHA-1. The DSA algorithm using the SHA-1 message digest algorithm can be specified as `SHA1withDSA`. In the case of RSA, there are multiple choices for the message digest algorithm, so the signing algorithm could be specified as, for example, `MD2withRSA`, `MD5withRSA`, or `SHA1withRSA`. The algorithm name must be specified, as there is no default.

Like other algorithm-based classes in Java Security, Signature provides implementation-independent algorithms, whereby a caller (application code) requests a particular signature algorithm and is handed back a properly initialized Signature object. It is also possible, if desired, to request a particular algorithm from a particular provider. See the `getInstance` methods.

Thus, there are two ways to request a Signature algorithm object: by specifying either just an algorithm name, or both an algorithm name and a package provider.

- If just an algorithm name is specified, the system will determine if there is an implementation of the algorithm requested available in the environment, and if there is more than one, if there is a preferred one.

- If both an algorithm name and a package provider are specified, the system will determine if there is an implementation of the algorithm in the package requested, and throw an exception if there is not.

A Signature object can be used to generate and verify digital signatures.

There are three phases to the use of a Signature object for either signing data or verifying a signature:

1. Initialization, with either
   - a public key, which initializes the signature for verification (see `initVerify`), or
   - a private key (and optionally a Secure Random Number Generator), which initializes the signature for signing (see `initSign(PrivateKey)` and `initSign(PrivateKey, SecureRandom)`).

2. Updating

   Depending on the type of initialization, this will update the bytes to be signed or verified. See the `update` methods.

3. Signing or Verifying a signature on all updated bytes. See the `sign` methods and the `verify` method.

Note that this class is abstract and extends from `SignatureSpi` for historical reasons. Application developers should only take notice of the methods defined in this `Signature` class; all the methods in the superclass are intended for cryptographic service providers who wish to supply their own implementations of digital signature algorithms.

Field Summary
`protected static int` | `SIGN` Possible `state` value, signifying that this signature object has been initialized for signing.
`protected int` | `state` Current state of this signature object.
`protected static int` | `UNINITIALIZED` Possible `state` value, signifying that this signature object has not yet been initialized.
`protected static int` | `VERIFY` Possible `state` value, signifying that this signature object has been initialized for verification.

Fields inherited from class java.security.SignatureSpi
`appRandom`

Constructor Summary
`protected` | `Signature(String algorithm)` Creates a Signature object for the specified algorithm.

Method Summary
`Object` | `clone()` Returns a clone if the implementation is cloneable.
`String` | `getAlgorithm()` Returns the name of the algorithm for this signature object.
`static Signature` | `getInstance(String algorithm)` Generates a Signature object that implements the specified digest algorithm.
`static Signature` | `getInstance(String algorithm, String provider)` Generates a Signature object implementing the specified algorithm, as supplied from the specified provider, if such an algorithm is available from the provider.
`Provider` | `getProvider()` Returns the provider of this signature object.
`void` | `initSign(PrivateKey privateKey)` Initialize this object for signing.
`void` | `initSign(PrivateKey privateKey, SecureRandom random)` Initialize this object for signing.
`void` | `initVerify(Certificate certificate)` Initializes this object for verification, using the public key from the given certificate.
`void` | `initVerify(PublicKey publicKey)` Initializes this object for verification.
`void` | `setParameter(AlgorithmParameterSpec params)` Initializes this signature engine with the specified parameter set.
`byte[]` | `sign()` Returns the signature bytes of all the data updated.
`int` | `sign(byte[] outbuf, int offset, int len)` Finishes the signature operation and stores the resulting signature bytes in the provided buffer `outbuf`, starting at `offset`.
`String` | `toString()` Returns a string representation of this signature object, providing information that includes the state of the object and the name of the algorithm used.
`void` | `update(byte b)` Updates the data to be signed or verified by a byte.
`void` | `update(byte[] data)` Updates the data to be signed or verified, using the specified array of bytes.
`void` | `update(byte[] data, int off, int len)` Updates the data to be signed or verified, using the specified array of bytes, starting at the specified offset.
`boolean` | `verify(byte[] signature)` Verifies the passed-in signature.

Methods inherited from class java.security.SignatureSpi
`engineInitSign, engineInitSign, engineInitVerify, engineSetParameter, engineSign, engineSign, engineUpdate, engineUpdate, engineVerify`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### UNINITIALIZED

    protected static final int UNINITIALIZED

  Possible `state` value, signifying that this signature object has not yet been initialized.

### SIGN

    protected static final int SIGN

  Possible `state` value, signifying that this signature object has been initialized for signing.

### VERIFY

    protected static final int VERIFY

  Possible `state` value, signifying that this signature object has been initialized for verification.

### state

    protected int state

  Current state of this signature object.

Constructor Detail

### Signature

    protected Signature(String algorithm)

  Creates a Signature object for the specified algorithm.
  Parameters:
    `algorithm` - the standard string name of the algorithm. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.

Method Detail

### getInstance

    public static Signature getInstance(String algorithm)
                                 throws NoSuchAlgorithmException

  Generates a Signature object that implements the specified digest algorithm. If the default provider package provides an implementation of the requested digest algorithm, an instance of Signature containing that implementation is returned. If the algorithm is not available in the default package, other packages are searched.
  Parameters:
    `algorithm` - the standard name of the algorithm requested. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
  Returns:
    the new Signature object.
  Throws:
    `NoSuchAlgorithmException` - if the algorithm is not available in the environment.

### getInstance

    public static Signature getInstance(String algorithm,
                                        String provider)
                                 throws NoSuchAlgorithmException,
                                        NoSuchProviderException

  Generates a Signature object implementing the specified algorithm, as supplied from the specified provider, if such an algorithm is available from the provider.
  Parameters:
    `algorithm` - the name of the algorithm requested. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
    `provider` - the name of the provider.
  Returns:
    the new Signature object.
  Throws:
    `NoSuchAlgorithmException` - if the algorithm is not available in the package supplied by the requested provider.
    `NoSuchProviderException` - if the provider is not available in the environment.
  See Also:
    `Provider`

### getProvider

    public final Provider getProvider()

  Returns the provider of this signature object.
  Returns:
    the provider of this signature object

### initVerify

    public final void initVerify(PublicKey publicKey)
                          throws InvalidKeyException

  Initializes this object for verification. If this method is called again with a different argument, it negates the effect of this call.
  Parameters:
    `publicKey` - the public key of the identity whose signature is going to be verified.
  Throws:
    `InvalidKeyException` - if the key is invalid.

### initVerify

    public final void initVerify(Certificate certificate)
                          throws InvalidKeyException

  Initializes this object for verification, using the public key from the given certificate.

  If the certificate is of type X.509 and has a key usage extension field marked as critical, and the value of the key usage extension field implies that the public key in the certificate and its corresponding private key are not supposed to be used for digital signatures, an `InvalidKeyException` is thrown.

  Parameters:
    `certificate` - the certificate of the identity whose signature is going to be verified.
  Throws:
    `InvalidKeyException` - if the public key in the certificate is not encoded properly or does not include required parameter information or cannot be used for digital signature purposes.

### initSign

    public final void initSign(PrivateKey privateKey)
                        throws InvalidKeyException

  Initialize this object for signing. If this method is called again with a different argument, it negates the effect of this call.
  Parameters:
    `privateKey` - the private key of the identity whose signature is going to be generated.
  Throws:
    `InvalidKeyException` - if the key is invalid.

### initSign

    public final void initSign(PrivateKey privateKey,
                               SecureRandom random)
                        throws InvalidKeyException

  Initialize this object for signing. If this method is called again with a different argument, it negates the effect of this call.
  Parameters:
    `privateKey` - the private key of the identity whose signature is going to be generated.
    `random` - the source of randomness for this signature.
  Throws:
    `InvalidKeyException` - if the key is invalid.

### sign

    public final byte[] sign()
                      throws SignatureException

  Returns the signature bytes of all the data updated. The format of the signature depends on the underlying signature scheme.

  A call to this method resets this signature object to the state it was in when previously initialized for signing via a call to `initSign(PrivateKey)`. That is, the object is reset and available to generate another signature from the same signer, if desired, via new calls to `update` and `sign`.

  Returns:
    the signature bytes of the signing operation's result.
  Throws:
    `SignatureException` - if this signature object is not initialized properly.

### sign

    public final int sign(byte[] outbuf,
                          int offset,
                          int len)
                   throws SignatureException

  Finishes the signature operation and stores the resulting signature bytes in the provided buffer `outbuf`, starting at `offset`. The format of the signature depends on the underlying signature scheme.

  This signature object is reset to its initial state (the state it was in after a call to one of the `initSign` methods) and can be reused to generate further signatures with the same private key.

  Parameters:
    `outbuf` - buffer for the signature result.
    `offset` - offset into `outbuf` where the signature is stored.
    `len` - number of bytes within `outbuf` allotted for the signature.
  Returns:
    the number of bytes placed into `outbuf`.
  Throws:
    `SignatureException` - if an error occurs or `len` is less than the actual signature length.
  Since:
    1.2

### verify

    public final boolean verify(byte[] signature)
                         throws SignatureException

  Verifies the passed-in signature.

  A call to this method resets this signature object to the state it was in when previously initialized for verification via a call to `initVerify(PublicKey)`. That is, the object is reset and available to verify another signature from the identity whose public key was specified in the call to `initVerify`.

  Parameters:
    `signature` - the signature bytes to be verified.
  Returns:
    true if the signature was verified, false if not.
  Throws:
    `SignatureException` - if this signature object is not initialized properly, or the passed-in signature is improperly encoded or of the wrong type, etc.

### update

    public final void update(byte b)
                      throws SignatureException

  Updates the data to be signed or verified by a byte.
  Parameters:
    `b` - the byte to use for the update.
  Throws:
    `SignatureException` - if this signature object is not initialized properly.

### update

    public final void update(byte[] data)
                      throws SignatureException

  Updates the data to be signed or verified, using the specified array of bytes.
  Parameters:
    `data` - the byte array to use for the update.
  Throws:
    `SignatureException` - if this signature object is not initialized properly.

### update

    public final void update(byte[] data,
                             int off,
                             int len)
                      throws SignatureException

  Updates the data to be signed or verified, using the specified array of bytes, starting at the specified offset.
  Parameters:
    `data` - the array of bytes.
    `off` - the offset to start from in the array of bytes.
    `len` - the number of bytes to use, starting at offset.
  Throws:
    `SignatureException` - if this signature object is not initialized properly.

### getAlgorithm

    public final String getAlgorithm()

  Returns the name of the algorithm for this signature object.
  Returns:
    the name of the algorithm for this signature object.

### toString

    public String toString()

  Returns a string representation of this signature object, providing information that includes the state of the object and the name of the algorithm used.
  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of this signature object.

### setParameter

    public final void setParameter(AlgorithmParameterSpec params)
                            throws InvalidAlgorithmParameterException

  Initializes this signature engine with the specified parameter set.
  Parameters:
    `params` - the parameters
  Throws:
    `InvalidAlgorithmParameterException` - if the given parameters are inappropriate for this signature engine

### clone

    public Object clone()
                 throws CloneNotSupportedException

  Returns a clone if the implementation is cloneable.
  Overrides:
    `clone` in class `SignatureSpi`
  Returns:
    a clone if the implementation is cloneable.
  Throws:
    `CloneNotSupportedException` - if this is called on an implementation that does not support `Cloneable`.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Java is a trademark or registred trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2000 Sun Microsystems, Inc. 901 San Antonio Road,
Palo, Alto, California, 94303, U.S.A All Rights Reserved. < /font >